
"""
Custom BListItem for the ColumnListView class.
"""

__author__    = "James Mayfield (james@mineralschool.net)"
__version__   = "$Revision: 1.0 $"
__date__      = "$Date: 2003/01/01 $"

from BListItem import BListItem

from InterfaceKit import *


class CLVItem(BListItem):
	def __init__(self, coldata, colheader, highlight=0):
		BListItem.__init__(self)
		self.coldata = coldata
		self.headers = colheader.GetColumn()
		
		alt = 0
		self.datlen = len(coldata)
		self.highlight = highlight
		
	def update(self, index=0, data=''):
		self.coldata[index] = data
		
		
	def DrawItem(self, owner, frame, com):
		l, t, r, b = frame
		owner.SetDrawingMode(B_OP_OVER)
		tmp = l
		count = 0
		
		if self.IsSelected():
			
			owner.SetHighColor((0,0,0,0))
			owner.FillRect(frame)
			for i in self.coldata:
				width = self.headers[count] + 2
				
				owner.SetHighColor((255,255,255,0))
				owner.MovePenTo(tmp + 4, b-2)
				leng = len(i)
				
				if leng*5 < width - 4:
					
					owner.DrawString(i)
					tmp = tmp + width
					count = count + 1
				else:
					divit = int(width / 5)
					owner.DrawString(i, i[:divit - 2]+'...',(tmp + 4 , b-2))
					tmp = tmp + width
					count = count + 1
		else:
			
			if self.highlight:
				owner.SetHighColor((245,245,245,0))
				owner.FillRect(frame)
				self.highlight = 1
			else:
				owner.SetHighColor((255,255,255,0))
				owner.FillRect(frame)
			for i in self.coldata:
			
				width = self.headers[count] + 2
				owner.SetHighColor((0,0,0,0))
				owner.MovePenTo(tmp + 4, b-2)
				leng = len(i)
		
				if leng*5 < width - 4:
					
					owner.DrawString(i)
					tmp = tmp + width
					count = count + 1
				else:
					divit = int(width / 5)
					owner.DrawString(i, i[:divit - 2]+'...',(tmp + 4 , b-2))
					tmp = tmp + width
					count = count + 1

		tmp = tmp + width
		count = count + 1