
"""
Python implementation of a ColumnListView class.
"""

__author__    = "James Mayfield (james@mineralschool.net)"
__version__   = "$Revision: 1.0 $"
__date__      = "$Date: 2003/01/01 $"

from BView import BView
from BScrollBar import BScrollBar
from ColumnListList import ColumnListList
from ColumnListHeader import ColumnListHeader

from InterfaceKit import *


class ColumnListView(BView):
	def __init__(self, rect, name):
		"""Takes a BRect (tuple) and a Name (string)"""
		BView.__init__(self, rect, name, B_FOLLOW_ALL_SIDES, B_WILL_DRAW|B_FRAME_EVENTS)
		l, t, r, b = rect

		parent = BView((l, t, r-16, b-16), 'parent',B_FOLLOW_ALL_SIDES, B_WILL_DRAW|B_FRAME_EVENTS)
		parent.SetViewColor((216, 216, 216, 0 ))
		self.listview = ColumnListList((l, t + 20, r +400, b-15), 'tl')
		vsb = BScrollBar((r-14, t, r, b), 'vsb', self.listview, 0.0, 100.0, B_VERTICAL)
		hsb = BScrollBar((l, b - 14, r-14, b), 'sb2', parent, 0.0, 400.0, B_HORIZONTAL)
		self.headers = ColumnListHeader((l, t, r+400, t + 20), 'headers', self.listview)
		
		self.AddChild(hsb)
		parent.AddChild(self.headers)
		parent.AddChild(self.listview)
		self.AddChild(parent)
		self.AddChild(vsb)
		
	def MakeColumns(self, columns, widths):
		"""Takes a list of Column Labels and a list of Column Widths, where the index 0 in each list correspond to the same column, etc"""
		
		self.headers.MakeColumn(columns, widths)

	def AddItem(self, itemlist, highlight=0):
		"""Takes a list of item.  The list MUST be the same length as the number of columns created"""
		self.listview.additem(itemlist, self.headers, highlight)