#!/boot/home/config/bin/python

import BApplication
from BWindow import BWindow
		
from StorageKit import *
from SupportKit import *
from InterfaceKit import *
from AppKit import *

from ColumnListView import ColumnListView

import os

class MainWindow(BWindow):
	def __init__(self, rect, title):
		BWindow.__init__(self, rect, title, B_TITLED_WINDOW, B_NOT_ZOOMABLE)
		rect = self.Bounds()
		
		collist = ColumnListView(rect, 'col')
		collist.MakeColumns(['File Name', 'File Size', 'Cool', 'Stuff'], [100, 50, 50, 100])
		
		self.AddChild(collist)
		ct = 0
	
		for item in os.listdir('/boot/home'):
		
			size_t = os.stat('/boot/home/' + item)[6]
			size_tt = size_t / 1024.0
			size_sp = `size_tt`.split('.')
			size = size_sp[0] + '.' + size_sp[1][:2]
			if ct:
				# add highlight to list item
				collist.AddItem([item, size, 'woo!', 'dude'], 1)
				ct = 0
			else:
				# dont add highlight to list item
				collist.AddItem([item, size, 'woo!', 'dude'])
				ct = 1
			
	def QuitRequested(self):
		BApplication.be_app.PostMessage(B_QUIT_REQUESTED)
		return 1

		
class MainApp(BApplication.BApplication):
	def __init__(self, sig, rect, title):
		BApplication.BApplication.__init__(self, sig)
		self.rect = rect
		self.title = title
		
	def ReadyToRun(self):
		window = MainWindow(self.rect, self.title)
		window.Show()

AppName = 'Python CLV Test'
Creator = 'Cube'
WindowSize = (100, 80, 760, 400)

# Start the App	
ThisApp = MainApp("application/x-vnd." + Creator + '-' + AppName, WindowSize, AppName)
ThisApp.Run()