#!/boot/home/config/bin/python

import BApplication
from BWindow import BWindow
from BScrollView import BScrollView
from BListView import BListView
from BStringItem import BStringItem
from BTextView import BTextView
from SplitView import Splitter
from BTabView import BTabView
from BTab import BTab

import os

from InterfaceKit import *
from AppKit import *

class MainWindow(BWindow):
	def __init__(self, rect, title):
		BWindow.__init__(self, rect, title, B_TITLED_WINDOW, B_QUIT_ON_WINDOW_CLOSE)
		rectt = self.Bounds()
		l, t, r, b = rectt
		
		# Build Splitters
		# 0 = vertical split | 1 = Horizontal split		
		split1 = Splitter(rectt, 'split',0)
		split2 = Splitter(rectt, 'split2', 1)
		
		# Build Views
		listview1 = listy((l,t,r,b), 'tl')
		textview = texty(r, b)
		tabview = tabby((l,t,r,b), 'tab')
		tabv_b = tabview.Bounds()
		ll,tt,rr,bb = tabv_b
		listview2 = listy((l+20, t + 20, r - 25, b - 55), 't32')
		scrollview1 = scrolly('Fancy Stuff', listview2, 1,1)
		tabview.AddTab(scrollview1)
		scrollview2 = scrolly('v2', textview, 1, 1)
		scrollview3 = scrolly('v3', listview1, 0, 1)
		self.AddChild(split1)
		
		# 1 = view1 is anchored | 2 = view2 is anchored
		# 25 = view1 takes 25% of thew window width or height
		split1.AddViews(scrollview3, split2, 1, 25)
		split1.SetConstraints(100, 100)
		split2.AddViews(scrollview2, tabview, 1, 50)
		split2.SetConstraints(50,50)
		
		textview.SetText('Hello World!')
		
		for item in os.listdir('/boot/home'):
			
			listview1.additem(item)
			listview2.additem(item)
		
	def QuitRequested(self):
		BApplication.be_app.PostMessage(B_QUIT_REQUESTED)
		return 1

class tabby(BTabView):
	def __init__(self, rect, name):
		BTabView.__init__(self, rect, name, B_WIDTH_AS_USUAL, B_FOLLOW_ALL_SIDES, B_WILL_DRAW)
		
class scrolly(BScrollView):
	def __init__(self, name, view, hor=1, ver=1):
		BScrollView.__init__(self, name, view, B_FOLLOW_ALL_SIDES, B_WILL_DRAW|B_FRAME_EVENTS, hor, ver, B_FANCY_BORDER)
		
class listy(BListView):
	def __init__(self, rect, name):
		BListView.__init__(self, rect, name ,B_SINGLE_SELECTION_LIST, B_FOLLOW_TOP_BOTTOM|B_FOLLOW_LEFT_RIGHT,B_WILL_DRAW|B_NAVIGABLE)

	def additem(self, item):
		item_add = BStringItem(item, 0)
		self.AddItem(item_add)

class texty(BTextView):
	def __init__(self,t,x):
		BTextView.__init__(self,(0,20,t-15,x),'View',(5,20,t+150,x),B_FOLLOW_ALL_SIDES,B_WILL_DRAW)
		self.SetStylable(1)
		self.MakeEditable(1)
		self.SetAutoindent(1)
		self.dent_lev = 0
		self.tmp_c = -1
	
class MainApp(BApplication.BApplication):
	def __init__(self, sig, rect, title):
		BApplication.BApplication.__init__(self, sig)
		self.rect = rect
		self.title = title
		
	def ReadyToRun(self):
		window = MainWindow(self.rect, self.title)
		window.Show()

AppName = 'SplitView Test App'
Creator = 'Cube'
WindowSize = (100, 80, 760, 400)

# Start the App	
ThisApp = MainApp("application/x-vnd." + Creator + '-' + AppName, WindowSize, AppName)
ThisApp.Run()